---
// Import data
import releasesData from "@data/releases.json";

// Import images
import gitNotificationImg from "@assets/img/symbols/git-notification.svg";
import bellNotificationImg from "@assets/img/symbols/bell-notification.svg";
import globalIconImg from "@assets/img/feature-matrix/global.svg";
import workingIconImg from "@assets/img/feature-matrix/working.svg";
import partialIconImg from "@assets/img/feature-matrix/partial.svg";
import notWorkingIconImg from "@assets/img/feature-matrix/not-working.svg";
import untestedIconImg from "@assets/img/feature-matrix/untested.svg";
import popularityLowImg from "@assets/img/symbols/popularity_low.svg";
import popularityMediumImg from "@assets/img/symbols/popularity_medium.svg";
import popularityHighImg from "@assets/img/symbols/popularity_high.svg";

const {
  portStatus,
  progressStage,
  progress,
  nextProgressStage,
  nextStageRequirements,
  supportStatus,
  untestedCount,
  releases,
  communitySize
} = Astro.props;
---

<!-- Features -->
<div id="portStatus" class="scrollspy feature-map mt-5">
  <div class="heading">
    <h2 class="h3 mb-0">Features & Usability</h2>

    <!-- Git rss notifications -->
    <a id="git-notification" class="btn btn-light d-print-none">
      <img class="dark-invert" src={gitNotificationImg.src} />
    </a>
    <tippy-tooltip
      class="d-none"
      data-tippy="#git-notification"
      data-placement="bottom-end"
    >
      <h2>Pro Tip</h2>
      Use
      <a target="_blank" class="link" href="http://gitlab.com/ubports">Gitlab</a
      >
      to subscribe to the linked Issues. So, whenever bugs get solved (or a fix needs
      testing) you will know about that.
    </tippy-tooltip>
  </div>

  {
    releases.filter((r) => !r.hidden).length > 1 &&
      releases
        .filter((r) => !r.hidden)
        .map((release) => (
          <span class="badge badge-secondary me-2 mb-3">
            <a href={release.path}>{release.prettyName}</a>
          </span>
        ))
  }

  <!--Progress-->
  <p class="small mb-2 light">
    <span class="bold">{progressStage.name}</span>

    <span
      id="device-next-stage-help"
      class="badge badge-secondary ms-2 normal-size"
    >
      State: {supportStatus}
    </span>
  </p>

  {
    !!nextProgressStage && (
      <tippy-tooltip
        class="d-none"
        data-tippy="#device-next-stage-help"
        data-placement="bottom-start"
        data-trigger="click"
      >
        <span>
          This is an aggregated rating of the device from the
          <a class="link" href="#supportStatus">
            support status indicators
          </a>
          . Supported devices are the most stable and up to date devices to
          choose from.
        </span>
        <br />
        <br />
        <span class="bold">Q: What does this port need to get better?</span>
        <br />
        <br />
        A: Complete the following features:
        <br />
        <br />
        <ul>
          {nextStageRequirements.map((missingFeature) => (
            <li>
              - <span class="text-orange small">{missingFeature}</span>
            </li>
          ))}
        </ul>
      </tippy-tooltip>
    )
  }

  <div class="progress mb-5">
    <div
      class="progress-bar"
      role="progressbar"
      style={"width: " + progress + "%"}
      aria-valuenow={progress}
      aria-valuemin="0"
      aria-valuemax="1"
    >
    </div>
  </div>

  <!--Usability-->
  <div class="usability-description row mb-5">
    <div class="col-sm">
      <p class="small mb-2 light">
        Automated Usability (<span class="bold">beta</span>)
      </p>
      <p>{progressStage.description}</p>
    </div>
    {
      !!communitySize && communitySize != 0 && (
        <div class="col-sm-auto mt-3 mt-sm-0">
          <p class="small mb-2 light text-sm-end">
            Community strength (<span class="bold">beta</span>)
          </p>
          <p>
            {communitySize <= 2 ? (
              <img class="ms-sm-auto" src={popularityLowImg.src} />
            ) : communitySize == 3 ? (
              <img class="ms-sm-auto" src={popularityMediumImg.src} />
            ) : (
              <img class="ms-sm-auto" src={popularityHighImg.src} />
            )}
          </p>
        </div>
      )
    }
  </div>

  <!-- Feature list-->
  <div class="features">
    {
      !!portStatus &&
        portStatus.map((featureCategory) => (
          <ul>
            <li>
              <p class="small me-2 light">{featureCategory.categoryName}:</p>
            </li>
            {featureCategory.features.map((feature) => (
              <li>
                <span class="feature-icon">
                  <img
                    src={
                      feature.value === "+"
                        ? workingIconImg.src
                        : feature.value === "+-"
                          ? partialIconImg.src
                          : feature.value === "-"
                            ? notWorkingIconImg.src
                            : untestedIconImg.src
                    }
                    class:list={{
                      "dark-invert":
                        feature.value != "+" && feature.value != "-"
                    }}
                  />
                  {!!feature.global && (
                    <img class="dark-invert" src={globalIconImg.src} />
                  )}
                </span>
                {feature.bugTracker ? (
                  <a
                    href={feature.bugTracker}
                    style={
                      "color: " + (feature.value != "+" ? "#555" : "inherit")
                    }
                    target={feature.bugTracker.startsWith("#") ? "" : "_blank"}
                    rel={
                      feature.bugTracker.startsWith("#")
                        ? ""
                        : "noreferrer noopener"
                    }
                  >
                    {feature.name}
                  </a>
                ) : (
                  <span
                    style={
                      "color: " + (feature.value != "+" ? "#555" : "inherit")
                    }
                  >
                    {feature.name}
                  </span>
                )}
              </li>
            ))}
          </ul>
        ))
    }
  </div>

  {
    !!portStatus && (
      <div class="feature-legend row mt-5">
        <div class="col-lg-3 col-md-6 card-body g-0">
          <img src={workingIconImg.src} />
          <span class="bold"> Working</span>
          <p>Confirmed, depending on the maintenance</p>
        </div>

        <div class="col-lg-3 col-md-6 card-body g-0">
          <img src={notWorkingIconImg.src} />
          <span class="bold">Not Working</span>
          <p>
            If there is a link here, follow it to learn more'
            <img class="dark-invert" src={bellNotificationImg.src} />'
          </p>
        </div>

        <div class="col-lg-3 col-md-6 card-body g-0">
          <img class="dark-invert" src={partialIconImg.src} />
          <span class="bold mb-3"> Partial</span>
          <p>Working to some extent but with issues</p>
        </div>

        <div class="col-lg-3 col-md-6 card-body g-0">
          <img class="dark-invert" src={globalIconImg.src} />
          <span class="bold"> Global Issue</span>
          <p>Issue is not specific to this device</p>
        </div>

        {!!untestedCount && (
          <div class="col-6 card-body g-0">
            <img class="dark-invert" src={untestedIconImg.src} />
            <span class="bold"> Untested</span>
            <p>Subject to port development</p>
          </div>
        )}
      </div>
    )
  }
</div>
